/*
 *  Linux kernel adaptation layers for owl wifi library.
 *  Copyright (C) 2010 HD Wireless AB
 *
 */

#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/string.h>
#include <linux/hardirq.h>
#include <linux/slab.h>
#include <stdarg.h>

/*
 * library functions needed by wl_api
 *
 */

int owl_os_init(void)
{
        return 0;
}

void *owl_mem_alloc(int size)
{
        return kmalloc(size, GFP_ATOMIC);
}

void owl_mem_free(void *p)
{
        kfree(p);
}

void *owl_os_memcpy(void *dst, const void *src, size_t n)
{
        return memcpy(dst, src, n);
}

void *owl_os_memset(void *s, int c, size_t n)
{
        return memset(s, c, n);
}

size_t owl_os_strlen(const char *s)
{
        return strlen(s);
}

char *owl_os_strncpy(char *dst, const char *src, size_t n)
{
        return strncpy(dst, src, n);
}

int owl_os_strncmp(const char *s1, const char *s2, size_t n)
{
        return strncmp(s1, s2, n);
}

char *owl_os_strcpy(char *dst, const char *src)
{
        return strcpy(dst, src);
}

int owl_os_memcmp(const void *s1, const void *s2, size_t n)
{
        return memcmp(s1, s2, n);
}

long int owl_os_strtol(const char *nptr, char **endptr, int base)
{
        return simple_strtol(nptr, endptr, base);
}

char *owl_os_strchr(const char *s, int c)
{
        return strchr(s, c);
}

int owl_os_snprintf(char *str, size_t size, const char *format, ...)
{
        return snprintf(str, size, format);
}

unsigned long int owl_os_strtoul(const char *nptr, char **endptr, int base)
{
        return simple_strtoul(nptr, endptr, base);
}

int owl_os_printf(const char *fmt, ...) {
        va_list args;
        char str[128];
        int len;
        
        va_start(args, fmt);
        len = vsnprintf(str, sizeof str, fmt, args);
        va_end(args);
        if ( len ) {
                printk(str);
        }

        return 0;
}
